import random
import math

U = int(input("Enter number of users : "))
K = int(input("Enter number of content in database : "))


choose_list = [0, 1]
user_list = []  # U*K list has been created


for i in range(0, U):

    user_list.append([])

    for j in range(0, K):
        # randomx is another random number
        # randomx will select from 1 and 0
        randomx = random.choice(choose_list)
        user_list[i].append(randomx)
print("user_list =")
print(user_list)

# count0 and count1 are list counting the 0 and 1 occurance
count1 = []
alpha_u2 = []
for i in range(0, U):
    # For each i a random number will be generated as probability to recomend content
    # Random number generated from 0.6 to 1 in aplha_u1
    # alpha_u2 is for precision upto 1 decimal place

    alpha_u1 = random.uniform(0.6, 1)
    alpha_u2.append(float("{:.1f}".format(alpha_u1)))

    count1.append(user_list[i].count(1))

print("alpha2 = ", alpha_u2)

print("count1 = ")
print(count1)

# MOVING TO FORMULA 1

# R_ui is total revenue
# r_ui is utility of content i to user u

R_ui = []
r_ui = []

for i in range(0, U):
    r_ui.append([])
    for j in range(0, K):
        # range (0,1) change because of atanh require value less than 1
        temp = random.uniform(0.01, 0.49)
        r_ui[i].append(float("{:.2f}".format(temp)))
print("r_ui =")
print(r_ui)


for i in range(0, U):

    R_ui.append([])

    for j in range(0, K):

        A_ui = random.uniform(0, 1)  # constant b/w 0 and 1
        A_ui = float("{:.2f}".format(A_ui))

        # fui is increasing functiuon on user_list content recomendation i.e., r

        f_ui = math.atanh(2*r_ui[i][j])
        f_ui = f_ui * A_ui
        R_ui[i].append(float("{:.2f}".format(f_ui)))
print("R_ui =")
print(R_ui)

sigma = 1  # size of content currently assumed to be 1 gb for all content

lamda = 0.12  # currncy unit per gb requested content currently taken as 10/gb

# MOVING TO FORMULA 2
U_cp = 0

# y0 is taking values from user choose_list(initial )
# y0 = user_list[i][j]
y0 = 1


# U_cp is initial utility of Content Provider
for i in range(0, U):

    for j in range(0, K):

      
        
        if count1[i] == 0:
            continue
        else:
            U_cp = U_cp + (alpha_u2[i]*y0*(R_ui[i][j]-sigma*lamda)/count1[i])

        # count1 is no content recommended to the user (Nu)

print("U_cp = ")
print(U_cp)


# MOVING TO FORMULA 3

content_list = list(range(0, K))
print(content_list)
size_cache = int(K/9)

cache_list = []

for i in range(0, 9):
    cache_list.append([])
    if i == 8:
        cache_list[i] = content_list.copy()
    else:
        for j in range(0, size_cache):
            random.shuffle(content_list)
            cache_list[i].append(content_list.pop())
print("cache_list =")
print(cache_list)

user_cache = []
for i in range(0, U):
    user_cache.append([])
    temp1 = random.randint(0, 8)
    temp2 = random.randint(0, 8)
    if temp1 == temp2:
        temp2 = random.randint(0, 9)
    user_cache[i].append(temp1)
    user_cache[i].append(temp2)

print("user_cache =")
print(user_cache)


cache_sigma = []
for i in range(0, 9):
    temp3 = random.uniform(0, 0.002)
    cache_sigma.append(float("{:.4f}".format(temp3)))

K_ui = []

# subset of cache c_u =2 assumed 
for i in range(0, U):
    K_ui.append([])
    for j in range(0,K):
        if j in cache_list[user_cache[i][0]]:
            K_ui[i].append(cache_sigma[user_cache[i][0]])
        elif j in cache_list[user_cache[i][1]]:
            K_ui[i].append(cache_sigma[user_cache[i][1]])
        else:
            K_ui[i].append(0)
  
print("K_ui =")          
print(K_ui)


# FORMULA 4

U0_cdn = 0

for i in range (0,U):
    for j in range(0,K):
        if count1[i]==0:
            continue
        else:
            U0_cdn = U0_cdn + ((alpha_u2[i] * y0 *(sigma * lamda - K_ui[i][j]) )/ count1[i])

print("U0_cdn = ")
print(U0_cdn)